regina::NPDF Class Referenceabstract
Basic Packet Types

A packet that can hold a PDF document. More...

`#include <packet/npdf.h>`

Inheritance diagram for regina::NPDF:

## Public Types

enum | OwnershipPolicy { OWN_MALLOC, OWN_NEW, DEEP_COPY }
| Describes how a PDF packet should claim ownership of a block of binary data. More...
typedef ChangeEventSpan | ChangeEventBlock
| A deprecated typedef for ChangeEventSpan. More...

## Public Member Functions

| NPDF ()
| Creates a PDF packet with no document stored. More...
| NPDF (const char *filename)
| Creates a PDF packet with data read from the given PDF file. More...
| NPDF (char *data, size_t size, OwnershipPolicy alloc)
| Creates a packet to store the given PDF data. More...
| ~NPDF ()
| Destroys this PDF packet and deallocates data if required. More...
bool | isNull () const
| Determines whether this packet is currently holding a PDF document. More...
const char * | data () const
| Returns a pointer to the block of raw data that forms this PDF document. More...
size_t | size () const
| Returns the size of this PDF document in bytes. More...
void | reset ()
| Empties this PDF packet so that no document is stored. More...
void | reset (char *data, size_t size, OwnershipPolicy alloc)
| Refills this PDF packet with the given PDF data. More...
bool | savePDF (const char *filename) const
| Saves this PDF document to the given file in PDF format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
Packet Identification
virtual PacketType | getPacketType () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | getPacketTypeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | getPacketLabel () const
| Returns the label associated with this individual packet. More...
std::string | getHumanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
void | setPacketLabel (const std::string &newLabel)
| Sets the label associated with this individual packet. More...
std::string | getFullName () const
| Returns a descriptive text string for the packet. More...
std::string | makeUniqueLabel (const std::string &base) const
| Returns a new label that cannot be found anywhere in the entire tree structure. More...
bool | makeUniqueLabels (NPacket *reference)
| Ensures that all packet labels in both this and the given packet tree combined are distinct. More...
Tags
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | getTags () const
| Returns the set of all tags associated with this packet. More...
Event Handling
bool | listen (NPacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (NPacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (NPacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
Tree Queries
NPacket * | getTreeParent () const
| Determines the parent packet in the tree structure. More...
NPacket * | getFirstTreeChild () const
| Determines the first child of this packet in the tree structure. More...
NPacket * | getLastTreeChild () const
| Determines the last child of this packet in the tree structure. More...
NPacket * | getNextTreeSibling () const
| Determines the next sibling of this packet in the tree structure. More...
NPacket * | getPrevTreeSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
NPacket * | getTreeMatriarch () const
| Determines the matriarch (the root) of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const NPacket *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const NPacket *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const NPacket *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
unsigned long | getNumberOfChildren () const
| Returns the number of immediate children of this packet. More...
unsigned long | getNumberOfDescendants () const
| Returns the total number of descendants of this packet. More...
unsigned long | getTotalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
Tree Manipulation
void | insertChildFirst (NPacket *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (NPacket *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (NPacket *newChild, NPacket *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (NPacket *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
Searching and Iterating
NPacket * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const NPacket * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
NPacket * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const NPacket * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
NPacket * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const NPacket * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
NPacket * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const NPacket * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
Packet Dependencies
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
Cloning
NPacket * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
File I/O
bool | save (const char *filename, bool compressed=true) const
| Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format. More...
void | writeXMLFile (std::ostream &out) const
| Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
Input and Output
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)

## Protected Member Functions

virtual NPacket * | internalClonePacket (NPacket *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...

## Detailed Description

A packet that can hold a PDF document.

This packet may or may not contain a PDF document at any given time. This can be tested by calling isNull(), and can be changed by calling reset().

## Member Typedef Documentation

typedef ChangeEventSpan regina::NPacket::ChangeEventBlock

inherited

A deprecated typedef for ChangeEventSpan.

Deprecated:
  ChangeEventSpan is now the correct way to fire a "packet changed" event. The class ChangeEventSpan is similar to the old ChangeEventBlock except that it fires both NPacketListener::packetToBeChanged() and NPacketListener::packetWasChanged() (on construction and destruction respectively), and the old boolean argument fireOnDestruction is gone (events are now fired always).

## Constructor & Destructor Documentation

regina::NPDF::NPDF | ( |  | ) |

inline

Creates a PDF packet with no document stored.

regina::NPDF::NPDF | ( | const char * | filename | ) |

Creates a PDF packet with data read from the given PDF file.

This routine does not check whether the given file looks like a PDF document; it simply loads the file contents blindly.

If the file could not be read or is empty, then no PDF document will be stored in this packet. You can test this by calling isNull().

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines.

Parameters

  filename | the filename of the PDF document to read.

regina::NPDF::NPDF | ( | char * | data,
|  | size_t | size,
|  | OwnershipPolicy | alloc
| ) |  |

inline

Creates a packet to store the given PDF data.

The data array must contain a full PDF document as a block of binary data.

The alloc argument shows if/how this packet claims ownership of the data. In particular, unless alloc is DEEP_COPY, this packet will claim ownership of the given data block and will deallocate it when the packet is destroyed. If alloc is DEEP_COPY then the given block of data will not be modified in any way.

It is possible to pass a null pointer as the data array, in which case the new packet will have no PDF document stored (so isNull() will return `true`).

Python:
  Not present.

Parameters

  data | the block of binary data that forms the PDF document, or `null` if no document is to be stored.
  size | the number of bytes in this block of binary data; if actual data is passed (i.e., data is not `null`) then this must be strictly positive.
  alloc | describes if/how this packet should claim ownership of the given block of data; see the notes above for details.

regina::NPDF::~NPDF | ( |  | ) |

inline

Destroys this PDF packet and deallocates data if required.

## Member Function Documentation

bool regina::NPacket::addTag | ( | const std::string & | tag | ) |

inherited

Associates the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Precondition
  The given tag is not the empty string.

Parameters

  tag | the tag to add.

Returns
  `true` if the given tag was successfully added, or `false` if the given tag was already present beforehand.

NPacket* regina::NPacket::clone | ( | bool | cloneDescendants = `false`,
|  | bool | end = `true`
| ) |  | const

inherited

Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet.

Note that any string tags associated with this packet will not be cloned.

If this packet has no parent in the tree structure, no clone will be created and 0 will be returned.

Parameters

  cloneDescendants | `true` if the descendants of this packet should also be cloned and inserted as descendants of the new packet. If this is passed as `false` (the default), only this packet will be cloned.
  end | `true` if the new packet should be inserted at the end of the parent's list of children (the default), or `false` if the new packet should be inserted as the sibling immediately after this packet.

Returns
  the newly inserted packet, or 0 if this packet has no parent.

const char * regina::NPDF::data | ( |  | ) | const

inline

Returns a pointer to the block of raw data that forms this PDF document.

The number of bytes in this block can be found by calling size().

If no PDF document is currently stored (i.e., isNull() returns `true`), then this routine will return a null pointer.

Python:
  Not present.

Returns
  the raw PDF data.

bool regina::NPDF::dependsOnParent | ( |  | ) | const

inline virtual

Determines if this packet depends upon its parent.

This is true if the parent cannot be altered without invalidating or otherwise upsetting this packet.

Returns
  `true` if and only if this packet depends on its parent.

Implements regina::NPacket.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NPacket* regina::NPacket::findPacketLabel | ( | const std::string & | label | ) |

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

const NPacket* regina::NPacket::findPacketLabel | ( | const std::string & | label | ) | const

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

NPacket* regina::NPacket::firstTreePacket | ( | const std::string & | type | ) |

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

const NPacket* regina::NPacket::firstTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

NPacket * regina::NPacket::getFirstTreeChild | ( |  | ) | const

inline inherited

Determines the first child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the first child packet, or 0 if there is none.

std::string regina::NPacket::getFullName | ( |  | ) | const

inherited

Returns a descriptive text string for the packet.

The string is of the form label (packet-type).

The packet label will be adjusted for human-readable output according to the behaviour of getHumanLabel().

Returns
  the descriptive text string.

std::string regina::NPacket::getHumanLabel | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet, adjusted if necessary for human-readable output.

In particular, if the packet has no label assigned then this routine will return "(no label)", not the empty string.

Warning
  The method by which this routine adjusts packet labels is subject to change in future versions of Regina.

Returns
  this individual packet's label.

NPacket * regina::NPacket::getLastTreeChild | ( |  | ) | const

inline inherited

Determines the last child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the last child packet, or 0 if there is none.

NPacket * regina::NPacket::getNextTreeSibling | ( |  | ) | const

inline inherited

Determines the next sibling of this packet in the tree structure.

This is the child of the parent that follows this packet.

This routine takes small constant time.

Returns
  the next sibling of this packet, or 0 if there is none.

unsigned long regina::NPacket::getNumberOfChildren | ( |  | ) | const

inherited

Returns the number of immediate children of this packet.

Grandchildren and so on are not counted.

Returns
  the number of immediate children.

unsigned long regina::NPacket::getNumberOfDescendants | ( |  | ) | const

inline inherited

Returns the total number of descendants of this packet.

This includes children, grandchildren and so on. This packet is not included in the count.

Returns
  the total number of descendants.

const std::string & regina::NPacket::getPacketLabel | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet.

An example is `MyTriangulation`. Each individual packet in the overall tree structure must have a unique label.

Returns
  this individual packet's label.

virtual PacketType regina::NPacket::getPacketType | ( |  | ) | const

pure virtual inherited

Returns the unique integer ID representing this type of packet.

This is the same for all packets of this class.

Returns
  the packet type ID.

virtual std::string regina::NPacket::getPacketTypeName | ( |  | ) | const

pure virtual inherited

Returns an English name for this type of packet.

An example is `NTriangulation`. This is the same for all packets of this class.

Returns
  the packet type name.

NPacket * regina::NPacket::getPrevTreeSibling | ( |  | ) | const

inline inherited

Determines the previous sibling of this packet in the tree structure.

This is the child of the parent that precedes this packet.

This routine takes small constant time.

Returns
  the previous sibling of this packet, or 0 if there is none.

const std::set< std::string > & regina::NPacket::getTags | ( |  | ) | const

inline inherited

Returns the set of all tags associated with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Python:
  This routine returns a python list of strings.

Returns
  the set of all tags associated with this packet.

unsigned long regina::NPacket::getTotalTreeSize | ( |  | ) | const

inherited

Determines the total number of packets in the tree or subtree for which this packet is matriarch.

This packet is included in the count.

Returns
  the total tree or subtree size.

NPacket* regina::NPacket::getTreeMatriarch | ( |  | ) | const

inherited

Determines the matriarch (the root) of the tree to which this packet belongs.

Returns
  the matriarch of the packet tree.

NPacket * regina::NPacket::getTreeParent | ( |  | ) | const

inline inherited

Determines the parent packet in the tree structure.

This routine takes small constant time.

Returns
  the parent packet, or 0 if there is none.

bool regina::NPacket::hasTag | ( | const std::string & | tag | ) | const

inline inherited

Determines whether this packet has the given associated tag.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to search for.

Returns
  `true` if the given tag is found, `false` otherwise.

bool regina::NPacket::hasTags | ( |  | ) | const

inline inherited

Determines whether this packet has any associated tags at all.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Returns
  `true` if this packet has any tags, `false` otherwise.

void regina::NPacket::insertChildAfter | ( | NPacket * | newChild,
|  | NPacket * | prevChild
| ) |  |

inherited

Inserts the given packet as a child of this packet at the given location in this packet's child list.

This routine takes small constant time.

Precondition
  Parameter newChild has no parent packet.
  Parameter prevChild is already a child of this packet.
  This packet is not a descendant of newChild.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  newChild | the child to insert.
  prevChild | the preexisting child of this packet after which newChild will be inserted, or 0 if newChild is to be the first child of this packet.

void regina::NPacket::insertChildFirst | ( | NPacket * | child | ) |

inherited

Inserts the given packet as the first child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

void regina::NPacket::insertChildLast | ( | NPacket * | child | ) |

inherited

Inserts the given packet as the last child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

NPacket * regina::NPDF::internalClonePacket | ( | NPacket * | parent | ) | const

inline protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Implements regina::NPacket.

std::string regina::NPacket::internalID | ( |  | ) | const

inherited

Returns a unique string ID that identifies this packet.

The user has no control over this ID, and it is not human readable. It is guaranteed to remain fixed throughout the lifetime of the program for a given packet, and it is guaranteed not to clash with the ID of any other packet.

If you change the contents of a packet, its ID will not change.

If you clone a packet, the new clone will receive a different ID. If you save and then load a packet to/from file, the ID will change. These behaviours are necessary to ensure that IDs remain unique (since, for instance, you could load several copies of the same data file into memory simultaneously).

The ID is implemented as an encoding of the underlying C++ pointer. This encoding is subject to change in later versions of Regina.

Returns
  a unique ID that identifies this packet.

bool regina::NPacket::isGrandparentOf | ( | const NPacket * | descendant | ) | const

inherited

Determines if this packet is equal to or an ancestor of the given packet in the tree structure.

Parameters

  descendant | the other packet whose relationships we are examining.

Returns
  `true` if and only if this packet is equal to or an ancestor of `descendant`.

bool regina::NPacket::isListening | ( | NPacketListener * | listener | ) |

inline inherited

Determines whether the given packet listener is currently listening for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to search for.

Returns
  `true` if the given listener is currently registered with this packet, or `false` otherwise.

bool regina::NPDF::isNull | ( |  | ) | const

inline

Determines whether this packet is currently holding a PDF document.

Returns
  `true` if and only if this packet is holding a PDF document.

bool regina::NPacket::isPacketEditable | ( |  | ) | const

inherited

Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children.

Descendants further down the packet tree are not (and should not need to be) considered.

Returns
  `true` if and only if this packet may be edited.

unsigned regina::NPacket::levelsDownTo | ( | const NPacket * | descendant | ) | const

inherited

Counts the number of levels between this packet and its given descendant in the tree structure.

If `descendant` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `descendant`, or can be obtained from `descendant` using only child-to-parent steps.

Parameters

  descendant | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

unsigned regina::NPacket::levelsUpTo | ( | const NPacket * | ancestor | ) | const

inline inherited

Counts the number of levels between this packet and its given ancestor in the tree structure.

If `ancestor` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `ancestor`, or can be obtained from `ancestor` using only parent-to-child steps.

Parameters

  ancestor | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

bool regina::NPacket::listen | ( | NPacketListener * | listener | ) |

inherited

Registers the given packet listener to listen for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to register.

Returns
  `true` if the given listener was successfully registered, or `false` if the given listener was already registered beforehand.

void regina::NPacket::makeOrphan | ( |  | ) |

inherited

Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree.

The tree information for both this packet and its parent will be updated.

This routine takes small constant time.

Precondition
  This packet has a parent.
  This packet does not depend on its parent; see dependsOnParent() for details.

Python:
  As of Regina 4.6.1, this routine returns the packet itself, and the ownership of this packet becomes the responsibility of whoever takes this return value. In particular, if you call makeOrphan() and ignore the return value then the entire packet subtree is automatically destroyed. The reason for this behaviour is to avoid memory leaks where subtrees are orphaned and then silently forgotten.

std::string regina::NPacket::makeUniqueLabel | ( | const std::string & | base | ) | const

inherited

Returns a new label that cannot be found anywhere in the entire tree structure.

This packet need not be the tree matriarch; this routine will search the entire tree to which this packet belongs.

The new label will consist of the given base, possibly followed by a space and a number.

Deprecated:
  This routine is deprecated, since (as of Regina 4.95) packet labels in a data file are no longer required to be distinct.

Parameters

  base | a string upon which the new label will be based.

Returns
  a new unique label.

bool regina::NPacket::makeUniqueLabels | ( | NPacket * | reference | ) |

inherited

Ensures that all packet labels in both this and the given packet tree combined are distinct.

If two packets have the same label, one will be renamed by adding a space and a number.

Packets in the given packet tree will be given priority over the labels; that is, if a packet in this tree has the same label as a packet in the given tree, it will be the packet in this tree that is renamed.

The given packet tree may be `null`, in which case only this tree will be examined.

Deprecated:
  This routine is deprecated, since (as of Regina 4.95) packet labels in a data file are no longer required to be distinct.

Precondition
  This and the given packet belong to different packet trees, and are each matriarchs in their respective trees.

Parameters

  reference | the packet tree with which to compare this tree.

Returns
  `true` if and only if any of the packets were relabelled.

void regina::NPacket::moveDown | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the end of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very end of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

void regina::NPacket::moveToFirst | ( |  | ) |

inherited

Moves this packet to be the first in its sibling list.

This routine takes small constant time.

void regina::NPacket::moveToLast | ( |  | ) |

inherited

Moves this packet to be the last in its sibling list.

This routine takes small constant time.

void regina::NPacket::moveUp | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the beginning of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very beginning of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

NPacket* regina::NPacket::nextTreePacket | ( |  | ) |

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

const NPacket* regina::NPacket::nextTreePacket | ( |  | ) | const

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

NPacket* regina::NPacket::nextTreePacket | ( | const std::string & | type | ) |

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

const NPacket* regina::NPacket::nextTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

void regina::NPacket::removeAllTags | ( |  | ) |

inherited

Removes all associated tags from this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

bool regina::NPacket::removeTag | ( | const std::string & | tag | ) |

inherited

Removes the association of the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to remove.

Returns
  `true` if the given tag was removed, or `false` if the given tag was not actually associated with this packet.

void regina::NPacket::reparent | ( | NPacket * | newParent,
|  | bool | first = `false`
| ) |  |

inherited

Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead.

This routine is essentially a combination of makeOrphan() followed by either insertChildFirst() or insertChildLast().

This routine takes small constant time. It is safe to use regardless of whether this packet has a parent or not.

Precondition
  This packet does not depend on its parent; see dependsOnParent() for details.
  The given parent is not a descendant of this packet.

Python:
  This routine is much simpler than combinations of makeOrphan() and insertChildFirst() / insertChildLast(), since there are no unpleasant ownership issues to deal with. However, if this packet currently has no parent then the ownership issues are unavoidable; in this case reparent() will do nothing, and one of the insertChild...() routines must be used instead.

Parameters

  newParent | the new parent of this packet, i.e., the packet beneath which this packet will be inserted.
  first | `true` if this packet should be inserted as the first child of the given parent, or `false` (the default) if it should be inserted as the last child.

void regina::NPDF::reset | ( |  | ) |

Empties this PDF packet so that no document is stored.

After calling this routine, isNull() will return `true`.

The old data will be deallocated if required.

void regina::NPDF::reset | ( | char * | data,
|  | size_t | size,
|  | OwnershipPolicy | alloc
| ) |  |

Refills this PDF packet with the given PDF data.

The old data will be deallocated if required.

This routine behaves like the class constructor; see the constructor documentation for details.

Python:
  Not present.

Parameters

  data | the block of binary data that forms the new PDF document, or `null` if no document is to be stored.
  size | the number of bytes in this new block of binary data; if actual data is passed (i.e., data is not `null`) then this must be strictly positive.
  alloc | describes if/how this packet should claim ownership of the given block of data; see the notes above for details.

bool regina::NPacket::save | ( | const char * | filename,
|  | bool | compressed = `true`
| ) |  | const

inherited

Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format.

The XML file may be optionally compressed (Regina can happily read both compressed and uncompressed XML).

This is the preferred way of saving a Regina data file. Typically this will be called from the root of the packet tree, which will save the entire packet tree to file.

Precondition
  The given packet does not depend on its parent.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written usign UTF-8.

Parameters

  filename | the pathname of the file to write to.
  compressed | `true` if the XML data should be compressed, or `false` if it should be written as plain text.

Returns
  `true` if and only if the file was successfully written.

bool regina::NPDF::savePDF | ( | const char * | filename | ) | const

Saves this PDF document to the given file in PDF format.

This routine does not check whether the contents of this packet look like a PDF document; it simply writes them blindly to the filesystem.

If no PDF document is currently stored in this PDF packet (i.e., isNull() returns `true`), then this routine will do nothing and simply return `false`.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it unchanged to low-level C/C++ file I/O routines.

Parameters

  filename | the name of the PDF file to write.

Returns
  `true` if the file was successfully written, or `false` otherwise.

void regina::NPacket::setPacketLabel | ( | const std::string & | newLabel | ) |

inherited

Sets the label associated with this individual packet.

Precondition
  No other packet in the overall tree structure has the same label.

Parameters

  newLabel | the new label to give this packet.

size_t regina::NPDF::size | ( |  | ) | const

inline

Returns the size of this PDF document in bytes.

If no PDF document is currently stored (i.e., isNull() returns `true`), then this routine will return zero.

Returns
  the number of bytes.

void regina::NPacket::sortChildren | ( |  | ) |

inherited

Sorts the immediate children of this packet according to their packet labels.

Note that this routine is not recursive (for instance, grandchildren will not be sorted within each child packet).

This routine takes quadratic time in the number of immediate children (and it's slow quadratic at that).

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

void regina::NPacket::swapWithNextSibling | ( |  | ) |

inherited

Swaps this packet with its next sibling in the sequence of children beneath their common parent packet.

Calling this routine is equivalent to calling moveDown().

This routine takes small constant time.

If this packet has no next sibling then this routine does nothing.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

bool regina::NPacket::unlisten | ( | NPacketListener * | listener | ) |

inherited

Unregisters the given packet listener so that it no longer listens for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to unregister.

Returns
  `true` if the given listener was successfully unregistered, or `false` if the given listener was not registered in the first place.

void regina::ShareableObject::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented in regina::NSnapPeaTriangulation, regina::NGroupPresentation, regina::NHomMarkedAbelianGroup, regina::NNormalSurfaceList, regina::NTetrahedron, regina::NSatRegion, regina::NVertex, regina::NEdge, regina::Dim2Triangle, regina::NTriangle, regina::NLayeredSolidTorus, regina::NHomGroupPresentation, regina::NGenericIsomorphism< dim >, regina::NGenericIsomorphism< 2 >, regina::NGenericIsomorphism< 3 >, regina::NTriangulation, regina::NComponent, regina::NTxICore, regina::NTriSolidTorus, regina::NAngleStructureList, regina::Dim2Edge, regina::NBoundaryComponent, regina::NLayeredChain, regina::Dim2Vertex, regina::Dim2Component, regina::NScript, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NSurfaceFilterProperties, regina::NLayeredTorusBundle, regina::NManifold, regina::NPlugTriSolidTorus, regina::NMatrixInt, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::Dim2Triangulation, regina::NSurfaceSubset, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NFileInfo, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::Dim2BoundaryComponent, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, regina::NText, regina::NSurfaceFilterCombination, and regina::NBlockedSFS.

void regina::NPDF::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

void regina::NPacket::writeXMLFile | ( | std::ostream & | out | ) | const

inherited

Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format.

Ths is similar to calling save(), except that (i) the user has a more flexible choice of output stream, and (ii) the XML will always be written in plain text (i.e., it will not be compressed).

If you simply wish to save your data to a file on the filesystem, you should call save() instead.

Typically this will be called from the root of the packet tree, which will write the entire packet tree to the output stream.

The output from this routine cannot be used as a piece of an XML file; it must be the entire XML file. For a piece of an XML file, see routine writeXMLPacketTree() instead.

Precondition
  This packet does not depend upon its parent.

Python:
  Not present.

Parameters

  out | the output stream to which the XML data file should be written.

virtual void regina::NPDF::writeXMLPacketData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the data for this packet only.

You may assume that the packet opening tag (including the packet type and label) has already been written, and that all child packets followed by the corresponding packet closing tag will be written immediately after this routine is called. This routine need only write the internal data stored in this specific packet.

Parameters

  out | the output stream to which the XML should be written.

Implements regina::NPacket.

void regina::NPacket::writeXMLPacketTree | ( | std::ostream & | out | ) | const

protected inherited

Writes a chunk of XML containing the subtree with this packet as matriarch.

This is the preferred way of writing a packet tree to file.

The output from this routine is only a piece of XML; it should not be used as a complete XML file. For a complete XML file, see routine writeXMLFile() instead.

Parameters

  out | the output stream to which the XML should be written.

The documentation for this class was generated from the following file:

- packet/npdf.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).